

// This C++ file was created by SanEditor

#include "Atomic/configuration_channel/configuration_channelSAN.h"

#include <stdlib.h>
#include <iostream>

#include <math.h>


/*****************************************************************
                         configuration_channelSAN Constructor             
******************************************************************/


configuration_channelSAN::configuration_channelSAN(){


  Correct_Incorrect_1Group.initialize(2, "Correct_Incorrect_1Group");
  Correct_Incorrect_1Group.appendGroup((BaseGroupClass*) &Correct_Incorrect_1_case1);
  Correct_Incorrect_1Group.appendGroup((BaseGroupClass*) &Correct_Incorrect_1_case2);

  Correct_Incorrect_2Group.initialize(2, "Correct_Incorrect_2Group");
  Correct_Incorrect_2Group.appendGroup((BaseGroupClass*) &Correct_Incorrect_2_case1);
  Correct_Incorrect_2Group.appendGroup((BaseGroupClass*) &Correct_Incorrect_2_case2);

  Incorrect_1_Incorrect_2Group.initialize(2, "Incorrect_1_Incorrect_2Group");
  Incorrect_1_Incorrect_2Group.appendGroup((BaseGroupClass*) &Incorrect_1_Incorrect_2_case1);
  Incorrect_1_Incorrect_2Group.appendGroup((BaseGroupClass*) &Incorrect_1_Incorrect_2_case2);

  Incorrect_2_Incorrect_1Group.initialize(2, "Incorrect_2_Incorrect_1Group");
  Incorrect_2_Incorrect_1Group.appendGroup((BaseGroupClass*) &Incorrect_2_Incorrect_1_case1);
  Incorrect_2_Incorrect_1Group.appendGroup((BaseGroupClass*) &Incorrect_2_Incorrect_1_case2);

  Restore_Conf_1Group.initialize(2, "Restore_Conf_1Group");
  Restore_Conf_1Group.appendGroup((BaseGroupClass*) &Restore_Conf_1_case1);
  Restore_Conf_1Group.appendGroup((BaseGroupClass*) &Restore_Conf_1_case2);

  Restore_Conf_2Group.initialize(2, "Restore_Conf_2Group");
  Restore_Conf_2Group.appendGroup((BaseGroupClass*) &Restore_Conf_2_case1);
  Restore_Conf_2Group.appendGroup((BaseGroupClass*) &Restore_Conf_2_case2);

  Activity* InitialActionList[12]={
    &Correct_Incorrect_1_case1, //0
    &Correct_Incorrect_1_case2, //1
    &Correct_Incorrect_2_case1, //2
    &Correct_Incorrect_2_case2, //3
    &Incorrect_1_Incorrect_2_case1, //4
    &Incorrect_1_Incorrect_2_case2, //5
    &Incorrect_2_Incorrect_1_case1, //6
    &Incorrect_2_Incorrect_1_case2, //7
    &Restore_Conf_1_case1, //8
    &Restore_Conf_1_case2, //9
    &Restore_Conf_2_case1, //10
    &Restore_Conf_2_case2  // 11
  };

  BaseGroupClass* InitialGroupList[6]={
    (BaseGroupClass*) &(Correct_Incorrect_1Group), 
    (BaseGroupClass*) &(Correct_Incorrect_2Group), 
    (BaseGroupClass*) &(Incorrect_1_Incorrect_2Group), 
    (BaseGroupClass*) &(Incorrect_2_Incorrect_1Group), 
    (BaseGroupClass*) &(Restore_Conf_1Group), 
    (BaseGroupClass*) &(Restore_Conf_2Group)
  };

  Correct = new Place("Correct" ,1);
  Incorrect_2 = new Place("Incorrect_2" ,0);
  Incorrect_1 = new Place("Incorrect_1" ,0);
  Attack_in_progress = new Place("Attack_in_progress" ,0);
  Channel_attacked_ID = new Place("Channel_attacked_ID" ,0);
  BaseStateVariableClass* InitialPlaces[5]={
    Correct,  // 0
    Incorrect_2,  // 1
    Incorrect_1,  // 2
    Attack_in_progress,  // 3
    Channel_attacked_ID   // 4
  };
  BaseStateVariableClass* InitialROPlaces[0]={
  };
  initializeSANModelNow("configuration_channel", 5, InitialPlaces, 
                        0, InitialROPlaces, 
                        12, InitialActionList, 6, InitialGroupList);


  assignPlacesToActivitiesInst();
  assignPlacesToActivitiesTimed();

  int AffectArcs[30][2]={ 
    {0,0}, {3,0}, {0,1}, {3,1}, {1,1}, {3,2}, {0,2}, {3,3}, {0,3}, 
    {2,3}, {2,4}, {3,4}, {2,5}, {3,5}, {1,5}, {1,6}, {3,6}, {1,7}, 
    {3,7}, {2,7}, {2,8}, {0,8}, {3,8}, {4,8}, {2,9}, {1,10}, 
    {0,10}, {3,10}, {4,10}, {1,11}
  };
  for(int n=0;n<30;n++) {
    AddAffectArc(InitialPlaces[AffectArcs[n][0]],
                 InitialActionList[AffectArcs[n][1]]);
  }
  int EnableArcs[20][2]={ 
    {0,0}, {3,0}, {0,1}, {3,1}, {3,2}, {0,2}, {3,3}, {0,3}, {2,4}, 
    {3,4}, {2,5}, {3,5}, {1,6}, {3,6}, {1,7}, {3,7}, {2,8}, {2,9}, 
    {1,10}, {1,11}
  };
  for(int n=0;n<20;n++) {
    AddEnableArc(InitialPlaces[EnableArcs[n][0]],
                 InitialActionList[EnableArcs[n][1]]);
  }

  for(int n=0;n<12;n++) {
    InitialActionList[n]->LinkVariables();
  }
  CustomInitialization();

}

void configuration_channelSAN::CustomInitialization() {

}
configuration_channelSAN::~configuration_channelSAN(){
  for (int i = 0; i < NumStateVariables-NumReadOnlyPlaces; i++)
    delete LocalStateVariables[i];
};

void configuration_channelSAN::assignPlacesToActivitiesInst(){
}
void configuration_channelSAN::assignPlacesToActivitiesTimed(){
  Correct_Incorrect_1_case1.Correct = (Place*) LocalStateVariables[0];
  Correct_Incorrect_1_case1.Attack_in_progress = (Place*) LocalStateVariables[3];
  Correct_Incorrect_1_case1.Channel_attacked_ID = (Place*) LocalStateVariables[4];
  Correct_Incorrect_1_case2.Correct = (Place*) LocalStateVariables[0];
  Correct_Incorrect_1_case2.Attack_in_progress = (Place*) LocalStateVariables[3];
  Correct_Incorrect_1_case2.Incorrect_2 = (Place*) LocalStateVariables[1];
  Correct_Incorrect_1_case2.Channel_attacked_ID = (Place*) LocalStateVariables[4];
  Correct_Incorrect_2_case1.Attack_in_progress = (Place*) LocalStateVariables[3];
  Correct_Incorrect_2_case1.Correct = (Place*) LocalStateVariables[0];
  Correct_Incorrect_2_case1.Channel_attacked_ID = (Place*) LocalStateVariables[4];
  Correct_Incorrect_2_case2.Attack_in_progress = (Place*) LocalStateVariables[3];
  Correct_Incorrect_2_case2.Correct = (Place*) LocalStateVariables[0];
  Correct_Incorrect_2_case2.Incorrect_1 = (Place*) LocalStateVariables[2];
  Correct_Incorrect_2_case2.Channel_attacked_ID = (Place*) LocalStateVariables[4];
  Incorrect_1_Incorrect_2_case1.Incorrect_1 = (Place*) LocalStateVariables[2];
  Incorrect_1_Incorrect_2_case1.Attack_in_progress = (Place*) LocalStateVariables[3];
  Incorrect_1_Incorrect_2_case1.Channel_attacked_ID = (Place*) LocalStateVariables[4];
  Incorrect_1_Incorrect_2_case2.Incorrect_1 = (Place*) LocalStateVariables[2];
  Incorrect_1_Incorrect_2_case2.Attack_in_progress = (Place*) LocalStateVariables[3];
  Incorrect_1_Incorrect_2_case2.Incorrect_2 = (Place*) LocalStateVariables[1];
  Incorrect_1_Incorrect_2_case2.Channel_attacked_ID = (Place*) LocalStateVariables[4];
  Incorrect_2_Incorrect_1_case1.Incorrect_2 = (Place*) LocalStateVariables[1];
  Incorrect_2_Incorrect_1_case1.Attack_in_progress = (Place*) LocalStateVariables[3];
  Incorrect_2_Incorrect_1_case1.Channel_attacked_ID = (Place*) LocalStateVariables[4];
  Incorrect_2_Incorrect_1_case2.Incorrect_2 = (Place*) LocalStateVariables[1];
  Incorrect_2_Incorrect_1_case2.Attack_in_progress = (Place*) LocalStateVariables[3];
  Incorrect_2_Incorrect_1_case2.Incorrect_1 = (Place*) LocalStateVariables[2];
  Incorrect_2_Incorrect_1_case2.Channel_attacked_ID = (Place*) LocalStateVariables[4];
  Restore_Conf_1_case1.Incorrect_1 = (Place*) LocalStateVariables[2];
  Restore_Conf_1_case1.Correct = (Place*) LocalStateVariables[0];
  Restore_Conf_1_case1.Attack_in_progress = (Place*) LocalStateVariables[3];
  Restore_Conf_1_case1.Channel_attacked_ID = (Place*) LocalStateVariables[4];
  Restore_Conf_1_case2.Incorrect_1 = (Place*) LocalStateVariables[2];
  Restore_Conf_2_case1.Incorrect_2 = (Place*) LocalStateVariables[1];
  Restore_Conf_2_case1.Correct = (Place*) LocalStateVariables[0];
  Restore_Conf_2_case1.Attack_in_progress = (Place*) LocalStateVariables[3];
  Restore_Conf_2_case1.Channel_attacked_ID = (Place*) LocalStateVariables[4];
  Restore_Conf_2_case2.Incorrect_2 = (Place*) LocalStateVariables[1];
}
/*****************************************************************/
/*                  Activity Method Definitions                  */
/*****************************************************************/

/*======================Correct_Incorrect_1Activity_case1========================*/

configuration_channelSAN::Correct_Incorrect_1Activity_case1::Correct_Incorrect_1Activity_case1(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("Correct_Incorrect_1_case1",0,Exponential, RaceEnabled, 2,2, false);
}

configuration_channelSAN::Correct_Incorrect_1Activity_case1::~Correct_Incorrect_1Activity_case1(){
  delete[] TheDistributionParameters;
}

void configuration_channelSAN::Correct_Incorrect_1Activity_case1::LinkVariables(){
  Correct->Register(&Correct_Mobius_Mark);
  Attack_in_progress->Register(&Attack_in_progress_Mobius_Mark);
  Channel_attacked_ID->Register(&Channel_attacked_ID_Mobius_Mark);
}

bool configuration_channelSAN::Correct_Incorrect_1Activity_case1::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(Correct_Mobius_Mark)) >=1)&&((*(Attack_in_progress_Mobius_Mark)) >=1));
  return NewEnabled;
}

double configuration_channelSAN::Correct_Incorrect_1Activity_case1::Rate(){
  return 2.77778E-07;
  return 1.0;  // default rate if none is specified
}

double configuration_channelSAN::Correct_Incorrect_1Activity_case1::Weight(){ 
  switch(Channel_attacked_ID->Mark())
  {
    case 1:
      return((double)(1.0) - attack_CH1_success_pr);
     break;
    case 2:
      return((double)(1.0) - attack_CH2_success_pr);
     break;
    default :
      return(1.0);
     break;
  }

}

bool configuration_channelSAN::Correct_Incorrect_1Activity_case1::ReactivationPredicate(){ 
  return false;
}

bool configuration_channelSAN::Correct_Incorrect_1Activity_case1::ReactivationFunction(){ 
  return false;
}

double configuration_channelSAN::Correct_Incorrect_1Activity_case1::SampleDistribution(){
  return TheDistribution->Exponential(2.77778E-07);
}

double* configuration_channelSAN::Correct_Incorrect_1Activity_case1::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int configuration_channelSAN::Correct_Incorrect_1Activity_case1::Rank(){
  return 1;
}

BaseActionClass* configuration_channelSAN::Correct_Incorrect_1Activity_case1::Fire(){
  (*(Correct_Mobius_Mark))--;
  (*(Attack_in_progress_Mobius_Mark))--;
  (*(Correct_Mobius_Mark))++;
  return this;
}

/*======================Correct_Incorrect_1Activity_case2========================*/

configuration_channelSAN::Correct_Incorrect_1Activity_case2::Correct_Incorrect_1Activity_case2(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("Correct_Incorrect_1_case2",0,Exponential, RaceEnabled, 3,2, false);
}

configuration_channelSAN::Correct_Incorrect_1Activity_case2::~Correct_Incorrect_1Activity_case2(){
  delete[] TheDistributionParameters;
}

void configuration_channelSAN::Correct_Incorrect_1Activity_case2::LinkVariables(){
  Correct->Register(&Correct_Mobius_Mark);
  Attack_in_progress->Register(&Attack_in_progress_Mobius_Mark);
  Incorrect_2->Register(&Incorrect_2_Mobius_Mark);
  Channel_attacked_ID->Register(&Channel_attacked_ID_Mobius_Mark);
}

bool configuration_channelSAN::Correct_Incorrect_1Activity_case2::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(Correct_Mobius_Mark)) >=1)&&((*(Attack_in_progress_Mobius_Mark)) >=1));
  return NewEnabled;
}

double configuration_channelSAN::Correct_Incorrect_1Activity_case2::Rate(){
  return 2.77778E-07;
  return 1.0;  // default rate if none is specified
}

double configuration_channelSAN::Correct_Incorrect_1Activity_case2::Weight(){ 
  switch(Channel_attacked_ID->Mark())
  {
    case 1:
      return(attack_CH1_success_pr);
     break;
    case 2:
      return(attack_CH2_success_pr);
     break;
    default :
      return(0.0);
     break;
  }
// if(Channel_attacked_ID->Mark() == 1)
//   return(attack_CH1_success_pr);
// else
//   return(attack_CH2_success_pr);

}

bool configuration_channelSAN::Correct_Incorrect_1Activity_case2::ReactivationPredicate(){ 
  return false;
}

bool configuration_channelSAN::Correct_Incorrect_1Activity_case2::ReactivationFunction(){ 
  return false;
}

double configuration_channelSAN::Correct_Incorrect_1Activity_case2::SampleDistribution(){
  return TheDistribution->Exponential(2.77778E-07);
}

double* configuration_channelSAN::Correct_Incorrect_1Activity_case2::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int configuration_channelSAN::Correct_Incorrect_1Activity_case2::Rank(){
  return 1;
}

BaseActionClass* configuration_channelSAN::Correct_Incorrect_1Activity_case2::Fire(){
  (*(Correct_Mobius_Mark))--;
  (*(Attack_in_progress_Mobius_Mark))--;
  (*(Incorrect_2_Mobius_Mark))++;
  return this;
}

/*======================Correct_Incorrect_2Activity_case1========================*/

configuration_channelSAN::Correct_Incorrect_2Activity_case1::Correct_Incorrect_2Activity_case1(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("Correct_Incorrect_2_case1",1,Exponential, RaceEnabled, 2,2, false);
}

configuration_channelSAN::Correct_Incorrect_2Activity_case1::~Correct_Incorrect_2Activity_case1(){
  delete[] TheDistributionParameters;
}

void configuration_channelSAN::Correct_Incorrect_2Activity_case1::LinkVariables(){
  Attack_in_progress->Register(&Attack_in_progress_Mobius_Mark);
  Correct->Register(&Correct_Mobius_Mark);
  Channel_attacked_ID->Register(&Channel_attacked_ID_Mobius_Mark);
}

bool configuration_channelSAN::Correct_Incorrect_2Activity_case1::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(Attack_in_progress_Mobius_Mark)) >=1)&&((*(Correct_Mobius_Mark)) >=1));
  return NewEnabled;
}

double configuration_channelSAN::Correct_Incorrect_2Activity_case1::Rate(){
  return 2.77778E-07;
  return 1.0;  // default rate if none is specified
}

double configuration_channelSAN::Correct_Incorrect_2Activity_case1::Weight(){ 
  switch(Channel_attacked_ID->Mark())
  {
    case 1:
      return((double)(1.0) - attack_CH1_success_pr);
     break;
    case 2:
      return((double)(1.0) - attack_CH2_success_pr);
     break;
    default :
      return(1.0);
     break;
  }
// if(Channel_attacked_ID->Mark() == 1)
//   return((double)(1.0) - attack_CH1_success_pr);
// else
//   return((double)(1.0) - attack_CH2_success_pr);

}

bool configuration_channelSAN::Correct_Incorrect_2Activity_case1::ReactivationPredicate(){ 
  return false;
}

bool configuration_channelSAN::Correct_Incorrect_2Activity_case1::ReactivationFunction(){ 
  return false;
}

double configuration_channelSAN::Correct_Incorrect_2Activity_case1::SampleDistribution(){
  return TheDistribution->Exponential(2.77778E-07);
}

double* configuration_channelSAN::Correct_Incorrect_2Activity_case1::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int configuration_channelSAN::Correct_Incorrect_2Activity_case1::Rank(){
  return 1;
}

BaseActionClass* configuration_channelSAN::Correct_Incorrect_2Activity_case1::Fire(){
  (*(Attack_in_progress_Mobius_Mark))--;
  (*(Correct_Mobius_Mark))--;
  (*(Correct_Mobius_Mark))++;
  return this;
}

/*======================Correct_Incorrect_2Activity_case2========================*/

configuration_channelSAN::Correct_Incorrect_2Activity_case2::Correct_Incorrect_2Activity_case2(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("Correct_Incorrect_2_case2",1,Exponential, RaceEnabled, 3,2, false);
}

configuration_channelSAN::Correct_Incorrect_2Activity_case2::~Correct_Incorrect_2Activity_case2(){
  delete[] TheDistributionParameters;
}

void configuration_channelSAN::Correct_Incorrect_2Activity_case2::LinkVariables(){
  Attack_in_progress->Register(&Attack_in_progress_Mobius_Mark);
  Correct->Register(&Correct_Mobius_Mark);
  Incorrect_1->Register(&Incorrect_1_Mobius_Mark);
  Channel_attacked_ID->Register(&Channel_attacked_ID_Mobius_Mark);
}

bool configuration_channelSAN::Correct_Incorrect_2Activity_case2::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(Attack_in_progress_Mobius_Mark)) >=1)&&((*(Correct_Mobius_Mark)) >=1));
  return NewEnabled;
}

double configuration_channelSAN::Correct_Incorrect_2Activity_case2::Rate(){
  return 2.77778E-07;
  return 1.0;  // default rate if none is specified
}

double configuration_channelSAN::Correct_Incorrect_2Activity_case2::Weight(){ 
  switch(Channel_attacked_ID->Mark())
  {
    case 1:
      return(attack_CH1_success_pr);
     break;
    case 2:
      return(attack_CH2_success_pr);
     break;
    default :
      return(0.0);
     break;
  }
// if(Channel_attacked_ID->Mark() == 1)
//   return(attack_CH1_success_pr);
// else
//   return(attack_CH2_success_pr);

}

bool configuration_channelSAN::Correct_Incorrect_2Activity_case2::ReactivationPredicate(){ 
  return false;
}

bool configuration_channelSAN::Correct_Incorrect_2Activity_case2::ReactivationFunction(){ 
  return false;
}

double configuration_channelSAN::Correct_Incorrect_2Activity_case2::SampleDistribution(){
  return TheDistribution->Exponential(2.77778E-07);
}

double* configuration_channelSAN::Correct_Incorrect_2Activity_case2::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int configuration_channelSAN::Correct_Incorrect_2Activity_case2::Rank(){
  return 1;
}

BaseActionClass* configuration_channelSAN::Correct_Incorrect_2Activity_case2::Fire(){
  (*(Attack_in_progress_Mobius_Mark))--;
  (*(Correct_Mobius_Mark))--;
  (*(Incorrect_1_Mobius_Mark))++;
  return this;
}

/*======================Incorrect_1_Incorrect_2Activity_case1========================*/

configuration_channelSAN::Incorrect_1_Incorrect_2Activity_case1::Incorrect_1_Incorrect_2Activity_case1(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("Incorrect_1_Incorrect_2_case1",2,Exponential, RaceEnabled, 2,2, false);
}

configuration_channelSAN::Incorrect_1_Incorrect_2Activity_case1::~Incorrect_1_Incorrect_2Activity_case1(){
  delete[] TheDistributionParameters;
}

void configuration_channelSAN::Incorrect_1_Incorrect_2Activity_case1::LinkVariables(){
  Incorrect_1->Register(&Incorrect_1_Mobius_Mark);
  Attack_in_progress->Register(&Attack_in_progress_Mobius_Mark);
  Channel_attacked_ID->Register(&Channel_attacked_ID_Mobius_Mark);
}

bool configuration_channelSAN::Incorrect_1_Incorrect_2Activity_case1::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(Incorrect_1_Mobius_Mark)) >=1)&&((*(Attack_in_progress_Mobius_Mark)) >=1));
  return NewEnabled;
}

double configuration_channelSAN::Incorrect_1_Incorrect_2Activity_case1::Rate(){
  return 0.0000001;
  return 1.0;  // default rate if none is specified
}

double configuration_channelSAN::Incorrect_1_Incorrect_2Activity_case1::Weight(){ 
  switch(Channel_attacked_ID->Mark())
  {
    case 1:
      return((double)(1.0) - attack_CH1_success_pr);
     break;
    case 2:
      return((double)(1.0) - attack_CH2_success_pr);
     break;
    default :
      return(0.0);
     break;
  }
// if(Channel_attacked_ID->Mark() == 1)
//   return((double)(1.0) - attack_CH1_success_pr);
// else
//   return((double)(1.0) - attack_CH2_success_pr);

}

bool configuration_channelSAN::Incorrect_1_Incorrect_2Activity_case1::ReactivationPredicate(){ 
  return false;
}

bool configuration_channelSAN::Incorrect_1_Incorrect_2Activity_case1::ReactivationFunction(){ 
  return false;
}

double configuration_channelSAN::Incorrect_1_Incorrect_2Activity_case1::SampleDistribution(){
  return TheDistribution->Exponential(0.0000001);
}

double* configuration_channelSAN::Incorrect_1_Incorrect_2Activity_case1::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int configuration_channelSAN::Incorrect_1_Incorrect_2Activity_case1::Rank(){
  return 1;
}

BaseActionClass* configuration_channelSAN::Incorrect_1_Incorrect_2Activity_case1::Fire(){
  (*(Incorrect_1_Mobius_Mark))--;
  (*(Attack_in_progress_Mobius_Mark))--;
  (*(Incorrect_1_Mobius_Mark))++;
  return this;
}

/*======================Incorrect_1_Incorrect_2Activity_case2========================*/

configuration_channelSAN::Incorrect_1_Incorrect_2Activity_case2::Incorrect_1_Incorrect_2Activity_case2(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("Incorrect_1_Incorrect_2_case2",2,Exponential, RaceEnabled, 3,2, false);
}

configuration_channelSAN::Incorrect_1_Incorrect_2Activity_case2::~Incorrect_1_Incorrect_2Activity_case2(){
  delete[] TheDistributionParameters;
}

void configuration_channelSAN::Incorrect_1_Incorrect_2Activity_case2::LinkVariables(){
  Incorrect_1->Register(&Incorrect_1_Mobius_Mark);
  Attack_in_progress->Register(&Attack_in_progress_Mobius_Mark);
  Incorrect_2->Register(&Incorrect_2_Mobius_Mark);
  Channel_attacked_ID->Register(&Channel_attacked_ID_Mobius_Mark);
}

bool configuration_channelSAN::Incorrect_1_Incorrect_2Activity_case2::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(Incorrect_1_Mobius_Mark)) >=1)&&((*(Attack_in_progress_Mobius_Mark)) >=1));
  return NewEnabled;
}

double configuration_channelSAN::Incorrect_1_Incorrect_2Activity_case2::Rate(){
  return 0.0000001;
  return 1.0;  // default rate if none is specified
}

double configuration_channelSAN::Incorrect_1_Incorrect_2Activity_case2::Weight(){ 
  switch(Channel_attacked_ID->Mark())
  {
    case 1:
      return(attack_CH1_success_pr);
     break;
    case 2:
      return(attack_CH2_success_pr);
     break;
    default :
      return(1.0);
     break;
  }
// if(Channel_attacked_ID->Mark() == 1)
//   return(attack_CH1_success_pr);
// else
//  return(attack_CH2_success_pr);

}

bool configuration_channelSAN::Incorrect_1_Incorrect_2Activity_case2::ReactivationPredicate(){ 
  return false;
}

bool configuration_channelSAN::Incorrect_1_Incorrect_2Activity_case2::ReactivationFunction(){ 
  return false;
}

double configuration_channelSAN::Incorrect_1_Incorrect_2Activity_case2::SampleDistribution(){
  return TheDistribution->Exponential(0.0000001);
}

double* configuration_channelSAN::Incorrect_1_Incorrect_2Activity_case2::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int configuration_channelSAN::Incorrect_1_Incorrect_2Activity_case2::Rank(){
  return 1;
}

BaseActionClass* configuration_channelSAN::Incorrect_1_Incorrect_2Activity_case2::Fire(){
  (*(Incorrect_1_Mobius_Mark))--;
  (*(Attack_in_progress_Mobius_Mark))--;
  (*(Incorrect_2_Mobius_Mark))++;
  return this;
}

/*======================Incorrect_2_Incorrect_1Activity_case1========================*/

configuration_channelSAN::Incorrect_2_Incorrect_1Activity_case1::Incorrect_2_Incorrect_1Activity_case1(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("Incorrect_2_Incorrect_1_case1",3,Exponential, RaceEnabled, 2,2, false);
}

configuration_channelSAN::Incorrect_2_Incorrect_1Activity_case1::~Incorrect_2_Incorrect_1Activity_case1(){
  delete[] TheDistributionParameters;
}

void configuration_channelSAN::Incorrect_2_Incorrect_1Activity_case1::LinkVariables(){
  Incorrect_2->Register(&Incorrect_2_Mobius_Mark);
  Attack_in_progress->Register(&Attack_in_progress_Mobius_Mark);
  Channel_attacked_ID->Register(&Channel_attacked_ID_Mobius_Mark);
}

bool configuration_channelSAN::Incorrect_2_Incorrect_1Activity_case1::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(Incorrect_2_Mobius_Mark)) >=1)&&((*(Attack_in_progress_Mobius_Mark)) >=1));
  return NewEnabled;
}

double configuration_channelSAN::Incorrect_2_Incorrect_1Activity_case1::Rate(){
  return 0.00001;
  return 1.0;  // default rate if none is specified
}

double configuration_channelSAN::Incorrect_2_Incorrect_1Activity_case1::Weight(){ 
  switch(Channel_attacked_ID->Mark())
  {
    case 1:
      return((double)(1.0) - attack_CH1_success_pr);
     break;
    case 2:
      return((double)(1.0) - attack_CH2_success_pr);
     break;
    default :
      return(0.0);
     break;
  }
// if(Channel_attacked_ID->Mark() == 1)
//   return((double)(1.0) - attack_CH1_success_pr);
// else
//  return((double)(1.0) - attack_CH2_success_pr);

}

bool configuration_channelSAN::Incorrect_2_Incorrect_1Activity_case1::ReactivationPredicate(){ 
  return false;
}

bool configuration_channelSAN::Incorrect_2_Incorrect_1Activity_case1::ReactivationFunction(){ 
  return false;
}

double configuration_channelSAN::Incorrect_2_Incorrect_1Activity_case1::SampleDistribution(){
  return TheDistribution->Exponential(0.00001);
}

double* configuration_channelSAN::Incorrect_2_Incorrect_1Activity_case1::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int configuration_channelSAN::Incorrect_2_Incorrect_1Activity_case1::Rank(){
  return 1;
}

BaseActionClass* configuration_channelSAN::Incorrect_2_Incorrect_1Activity_case1::Fire(){
  (*(Incorrect_2_Mobius_Mark))--;
  (*(Attack_in_progress_Mobius_Mark))--;
  (*(Incorrect_2_Mobius_Mark))++;
  return this;
}

/*======================Incorrect_2_Incorrect_1Activity_case2========================*/

configuration_channelSAN::Incorrect_2_Incorrect_1Activity_case2::Incorrect_2_Incorrect_1Activity_case2(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("Incorrect_2_Incorrect_1_case2",3,Exponential, RaceEnabled, 3,2, false);
}

configuration_channelSAN::Incorrect_2_Incorrect_1Activity_case2::~Incorrect_2_Incorrect_1Activity_case2(){
  delete[] TheDistributionParameters;
}

void configuration_channelSAN::Incorrect_2_Incorrect_1Activity_case2::LinkVariables(){
  Incorrect_2->Register(&Incorrect_2_Mobius_Mark);
  Attack_in_progress->Register(&Attack_in_progress_Mobius_Mark);
  Incorrect_1->Register(&Incorrect_1_Mobius_Mark);
  Channel_attacked_ID->Register(&Channel_attacked_ID_Mobius_Mark);
}

bool configuration_channelSAN::Incorrect_2_Incorrect_1Activity_case2::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(Incorrect_2_Mobius_Mark)) >=1)&&((*(Attack_in_progress_Mobius_Mark)) >=1));
  return NewEnabled;
}

double configuration_channelSAN::Incorrect_2_Incorrect_1Activity_case2::Rate(){
  return 0.00001;
  return 1.0;  // default rate if none is specified
}

double configuration_channelSAN::Incorrect_2_Incorrect_1Activity_case2::Weight(){ 
  switch(Channel_attacked_ID->Mark())
  {
    case 1:
      return(attack_CH1_success_pr);
     break;
    case 2:
      return(attack_CH2_success_pr);
     break;
    default :
      return(1.0);
     break;
  }
// if(Channel_attacked_ID->Mark() == 1)
//   return(attack_CH1_success_pr);
// else
//   return(attack_CH2_success_pr);

}

bool configuration_channelSAN::Incorrect_2_Incorrect_1Activity_case2::ReactivationPredicate(){ 
  return false;
}

bool configuration_channelSAN::Incorrect_2_Incorrect_1Activity_case2::ReactivationFunction(){ 
  return false;
}

double configuration_channelSAN::Incorrect_2_Incorrect_1Activity_case2::SampleDistribution(){
  return TheDistribution->Exponential(0.00001);
}

double* configuration_channelSAN::Incorrect_2_Incorrect_1Activity_case2::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int configuration_channelSAN::Incorrect_2_Incorrect_1Activity_case2::Rank(){
  return 1;
}

BaseActionClass* configuration_channelSAN::Incorrect_2_Incorrect_1Activity_case2::Fire(){
  (*(Incorrect_2_Mobius_Mark))--;
  (*(Attack_in_progress_Mobius_Mark))--;
  (*(Incorrect_1_Mobius_Mark))++;
  return this;
}

/*======================Restore_Conf_1Activity_case1========================*/

configuration_channelSAN::Restore_Conf_1Activity_case1::Restore_Conf_1Activity_case1(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("Restore_Conf_1_case1",4,Deterministic, RaceEnabled, 4,1, false);
}

configuration_channelSAN::Restore_Conf_1Activity_case1::~Restore_Conf_1Activity_case1(){
  delete[] TheDistributionParameters;
}

void configuration_channelSAN::Restore_Conf_1Activity_case1::LinkVariables(){
  Incorrect_1->Register(&Incorrect_1_Mobius_Mark);
  Correct->Register(&Correct_Mobius_Mark);
  Attack_in_progress->Register(&Attack_in_progress_Mobius_Mark);
  Channel_attacked_ID->Register(&Channel_attacked_ID_Mobius_Mark);
}

bool configuration_channelSAN::Restore_Conf_1Activity_case1::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(Incorrect_1_Mobius_Mark)) >=1));
  return NewEnabled;
}

double configuration_channelSAN::Restore_Conf_1Activity_case1::DeterministicParamValue(){
  return Configuration_validation_Duration;
  return 1.0;  // default rate if none is specified
}

double configuration_channelSAN::Restore_Conf_1Activity_case1::Weight(){ 
  return(Config_repair_success);
}

bool configuration_channelSAN::Restore_Conf_1Activity_case1::ReactivationPredicate(){ 
  return false;
}

bool configuration_channelSAN::Restore_Conf_1Activity_case1::ReactivationFunction(){ 
  return false;
}

double configuration_channelSAN::Restore_Conf_1Activity_case1::SampleDistribution(){
  return Configuration_validation_Duration;
}

double* configuration_channelSAN::Restore_Conf_1Activity_case1::ReturnDistributionParameters(){
  TheDistributionParameters[0] = DeterministicParamValue();
  return TheDistributionParameters;
}

int configuration_channelSAN::Restore_Conf_1Activity_case1::Rank(){
  return 1;
}

BaseActionClass* configuration_channelSAN::Restore_Conf_1Activity_case1::Fire(){
  (*(Incorrect_1_Mobius_Mark))--;
  if(Attack_in_progress->Mark() == 0)
  Channel_attacked_ID->Mark() = 0;
  (*(Correct_Mobius_Mark))++;
  return this;
}

/*======================Restore_Conf_1Activity_case2========================*/

configuration_channelSAN::Restore_Conf_1Activity_case2::Restore_Conf_1Activity_case2(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("Restore_Conf_1_case2",4,Deterministic, RaceEnabled, 1,1, false);
}

configuration_channelSAN::Restore_Conf_1Activity_case2::~Restore_Conf_1Activity_case2(){
  delete[] TheDistributionParameters;
}

void configuration_channelSAN::Restore_Conf_1Activity_case2::LinkVariables(){
  Incorrect_1->Register(&Incorrect_1_Mobius_Mark);
}

bool configuration_channelSAN::Restore_Conf_1Activity_case2::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(Incorrect_1_Mobius_Mark)) >=1));
  return NewEnabled;
}

double configuration_channelSAN::Restore_Conf_1Activity_case2::DeterministicParamValue(){
  return Configuration_validation_Duration;
  return 1.0;  // default rate if none is specified
}

double configuration_channelSAN::Restore_Conf_1Activity_case2::Weight(){ 
  return((double)(1.0) - Config_repair_success);
}

bool configuration_channelSAN::Restore_Conf_1Activity_case2::ReactivationPredicate(){ 
  return false;
}

bool configuration_channelSAN::Restore_Conf_1Activity_case2::ReactivationFunction(){ 
  return false;
}

double configuration_channelSAN::Restore_Conf_1Activity_case2::SampleDistribution(){
  return Configuration_validation_Duration;
}

double* configuration_channelSAN::Restore_Conf_1Activity_case2::ReturnDistributionParameters(){
  TheDistributionParameters[0] = DeterministicParamValue();
  return TheDistributionParameters;
}

int configuration_channelSAN::Restore_Conf_1Activity_case2::Rank(){
  return 1;
}

BaseActionClass* configuration_channelSAN::Restore_Conf_1Activity_case2::Fire(){
  (*(Incorrect_1_Mobius_Mark))--;
  (*(Incorrect_1_Mobius_Mark))++;
  return this;
}

/*======================Restore_Conf_2Activity_case1========================*/

configuration_channelSAN::Restore_Conf_2Activity_case1::Restore_Conf_2Activity_case1(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("Restore_Conf_2_case1",5,Deterministic, RaceEnabled, 4,1, false);
}

configuration_channelSAN::Restore_Conf_2Activity_case1::~Restore_Conf_2Activity_case1(){
  delete[] TheDistributionParameters;
}

void configuration_channelSAN::Restore_Conf_2Activity_case1::LinkVariables(){
  Incorrect_2->Register(&Incorrect_2_Mobius_Mark);
  Correct->Register(&Correct_Mobius_Mark);
  Attack_in_progress->Register(&Attack_in_progress_Mobius_Mark);
  Channel_attacked_ID->Register(&Channel_attacked_ID_Mobius_Mark);
}

bool configuration_channelSAN::Restore_Conf_2Activity_case1::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(Incorrect_2_Mobius_Mark)) >=1));
  return NewEnabled;
}

double configuration_channelSAN::Restore_Conf_2Activity_case1::DeterministicParamValue(){
  return Configuration_validation_Duration;
  return 1.0;  // default rate if none is specified
}

double configuration_channelSAN::Restore_Conf_2Activity_case1::Weight(){ 
  return(Config_repair_success);
}

bool configuration_channelSAN::Restore_Conf_2Activity_case1::ReactivationPredicate(){ 
  return false;
}

bool configuration_channelSAN::Restore_Conf_2Activity_case1::ReactivationFunction(){ 
  return false;
}

double configuration_channelSAN::Restore_Conf_2Activity_case1::SampleDistribution(){
  return Configuration_validation_Duration;
}

double* configuration_channelSAN::Restore_Conf_2Activity_case1::ReturnDistributionParameters(){
  TheDistributionParameters[0] = DeterministicParamValue();
  return TheDistributionParameters;
}

int configuration_channelSAN::Restore_Conf_2Activity_case1::Rank(){
  return 1;
}

BaseActionClass* configuration_channelSAN::Restore_Conf_2Activity_case1::Fire(){
  (*(Incorrect_2_Mobius_Mark))--;
  if(Attack_in_progress->Mark() == 0)
  Channel_attacked_ID->Mark() = 0;
  (*(Correct_Mobius_Mark))++;
  return this;
}

/*======================Restore_Conf_2Activity_case2========================*/

configuration_channelSAN::Restore_Conf_2Activity_case2::Restore_Conf_2Activity_case2(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("Restore_Conf_2_case2",5,Deterministic, RaceEnabled, 1,1, false);
}

configuration_channelSAN::Restore_Conf_2Activity_case2::~Restore_Conf_2Activity_case2(){
  delete[] TheDistributionParameters;
}

void configuration_channelSAN::Restore_Conf_2Activity_case2::LinkVariables(){
  Incorrect_2->Register(&Incorrect_2_Mobius_Mark);
}

bool configuration_channelSAN::Restore_Conf_2Activity_case2::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(Incorrect_2_Mobius_Mark)) >=1));
  return NewEnabled;
}

double configuration_channelSAN::Restore_Conf_2Activity_case2::DeterministicParamValue(){
  return Configuration_validation_Duration;
  return 1.0;  // default rate if none is specified
}

double configuration_channelSAN::Restore_Conf_2Activity_case2::Weight(){ 
  return((double)(1.0) - Config_repair_success);
}

bool configuration_channelSAN::Restore_Conf_2Activity_case2::ReactivationPredicate(){ 
  return false;
}

bool configuration_channelSAN::Restore_Conf_2Activity_case2::ReactivationFunction(){ 
  return false;
}

double configuration_channelSAN::Restore_Conf_2Activity_case2::SampleDistribution(){
  return Configuration_validation_Duration;
}

double* configuration_channelSAN::Restore_Conf_2Activity_case2::ReturnDistributionParameters(){
  TheDistributionParameters[0] = DeterministicParamValue();
  return TheDistributionParameters;
}

int configuration_channelSAN::Restore_Conf_2Activity_case2::Rank(){
  return 1;
}

BaseActionClass* configuration_channelSAN::Restore_Conf_2Activity_case2::Fire(){
  (*(Incorrect_2_Mobius_Mark))--;
  (*(Incorrect_2_Mobius_Mark))++;
  return this;
}

