#ifndef Div_SWRJ__Channel_2_H_
#define Div_SWRJ__Channel_2_H_
#include <math.h>
#include "Cpp/Composer/Join.h"
#include "Cpp/Composer/AllStateVariableTypes.h"
#include "Atomic/SW_channel/SW_channelSAN.h"
#include "Atomic/configuration_channel/configuration_channelSAN.h"
#include "Atomic/Control_configuration_channel/Control_configuration_channelSAN.h"

//State variable headers
#include "Cpp/BaseClasses/SAN/Place.h"

class Div_SWRJ__Channel_2: public Join {
 public:
  SW_channelSAN * SW_channel_2;
  configuration_channelSAN * configuration_channel_2;
  Control_configuration_channelSAN * Control_conf_channel_2;
  Place * Attack_enabled;
  Place * CCF_active;
  Place * CH2_OK;
  Place * CH2_Safe_state;
  Place * C_attack_enabled;
  Place * Channel_attacked_ID;
  Place * ConfigurationOK;
  Place * System_OK;
  Place * Unsafe_state_2;

  Div_SWRJ__Channel_2();
  ~Div_SWRJ__Channel_2();
};

#endif
